<template>
  <ob-form
    :form-data="formData"
    :form-model="formModel"
    :is-read-only="isReadOnlyForm"
    :dropdown-menu="dropdownMenu"
    @submit="onSubmitHandler"
    @close="selectedTab = tabsItems[0]"
  >
    <ob-tabs
      :items="tabsItems"
      v-model="selectedTab"
      @on-change-tab="onChangeTab"
    >
      <ob-tabs-pane :title="tabsItems[0].title">
        <div class="row">
          <div class="col-xs-12">
            <ob-input
              :label="`Наименование типа груза`"
              v-model="formData.name"
              :disabled="!isNew"
              placeholder="Введите название"
              property="name"
            />
          </div>
        </div>
        <div
          v-if="formData.conversion_scheme && formData.conversion_scheme[0]"
          class="row custom-row"
        >
          <div class="col-xs-2">
            <ob-stepper
              :label="`Кол-во`"
              v-model.number="formData.conversion_scheme[0].amount"
              :disabled="true"
              property="conversion_scheme.0.amount"
            />
          </div>
          <div class="col-xs-2 custom-col">
            <ob-select
              :label="`Единица`"
              v-if="!isNew"
              v-model="formData.conversion_scheme[0].forwarding_unit.uuid"
              :items="[formData.conversion_scheme[0].forwarding_unit]"
              :disabled="true"
              display-exp="name"
              value-exp="uuid"
              :is-standart="true"
              property="conversion_scheme.0.forwarding_unit.uuid"
            />

            <ob-select
              :label="`Единица`"
              v-if="isNew"
              v-model="formData.conversion_scheme[0].forwarding_unit.uuid"
              :disabled="true"
              display-exp="denomination"
              value-exp="uuid"
              :is-standart="true"
              :is-auto-complete="true"
              :remote-opt="{
                method: getForwardingUnits,
                loadEvent: 'open'
              }"
              property="conversion_scheme.0.forwarding_unit.uuid"
            />
            <span class="equal-char">
              =
            </span>
          </div>
          <div class="col-xs-2">
            <ob-stepper
              :label="`Кол-во`"
              v-model.number="formData.conversion_scheme[1].amount"
              :disabled="true"
              property="conversion_scheme.1.amount"
            />
          </div>
          <div class="col-xs-2 custom-col">
            <ob-select
              :label="`Единица`"
              v-if="!isNew"
              v-model="formData.conversion_scheme[1].forwarding_unit.uuid"
              :items="[formData.conversion_scheme[1].forwarding_unit]"
              :disabled="true"
              display-exp="name"
              value-exp="uuid"
              :is-standart="true"
              property="conversion_scheme.1.forwarding_unit.uuid"
            />
            <ob-select
              :label="`Единица`"
              v-if="isNew"
              v-model="formData.conversion_scheme[1].forwarding_unit.uuid"
              :disabled="true"
              display-exp="denomination"
              value-exp="uuid"
              :is-standart="true"
              :is-auto-complete="true"
              :remote-opt="{
                method: getForwardingUnits,
                loadEvent: 'open'
              }"
              property="conversion_scheme.1.forwarding_unit.uuid"
            />
            <span class="equal-char">
              =
            </span>
          </div>
          <div class="col-xs-2 custom-col">
            <ob-stepper
              :label="`Вес, кг`"
              v-model.number="formData.weight"
              :disabled="true"
              property="weight"
            />
            <span class="equal-char">
              =
            </span>
          </div>
          <div class="col-xs-2">
            <ob-stepper
              :label="`Объем, куб.метр`"
              v-model.number="formData.volume"
              :disabled="true"
              property="volume"
            />
          </div>
        </div>
      </ob-tabs-pane>
      <ob-tabs-pane
        name="key_words"
        :title="tabsItems[1].title"
      >
        <ob-select
          :items="preparedKeyWords"
          :label="`Ключевые слова`"
          :disabled="disabledKeyWords"
          v-model="formData.key_words"
          :is-input="true"
          valueExp="title"
          display-exp="title"
          placeholder="Введите ключевые слова"
          :is-multiselect="true"
          :is-standart="true"
          @focus-out="onFocusOut"
          property="key_words"
        />
        <div class="ob-selector__multi-select">
          <span
              v-for="(item, index) in formData.key_words"
              :key="index"
              class="ob-selector__multi-select-item"
              style="display: flex;"
          >
            <span>{{item}}</span>
            <i 
                @click="deleteKeyWord(item)"
                class="icon close ob-selector__multi-select-item-remove"
            />
          </span>
        </div>
      </ob-tabs-pane>
    </ob-tabs>
  </ob-form>
</template>

<script>
import api                                from '@/api';
import models                             from '@/models';
import cloneDeep                          from 'clone-deep';
import dropdownEvents                     from '@/mixins/dictionaries/dropdown-events.js';
import { TEMPERATURE_MODE_ICONS_BY_NAME } from '@/resources/enum';

import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin';
import ObForm              from 'common-components/src/obComponents/obForm';
import ObInput             from 'common-components/src/obComponents/obInput';
import ObSelect            from 'common-components/src/obComponents/obSelect';
import ObStepper           from 'common-components/src/obComponents/obStepper';
import ObTabs              from 'common-components/src/obComponents/obTabs';
import ObTabsPane          from 'common-components/src/obComponents/obTabs/ObTabsPane';

export default {
  name: 'CargoType',
  components: {
    ObStepper,
    ObSelect,
    ObInput,
    ObForm,
    ObTabs,
    ObTabsPane
  },
  mixins: [
    FormValidationMixin,
    dropdownEvents
  ],
  computed: {
    preparedKeyWords() {
      return this.formData.key_words
        ? this.formData.key_words.map(key => {
            return { title: key };
          })
        : [];
    },
    isReadOnlyForm() {
      if (this.isNew) return false;
      else if (this.dataSource.is_active) return this.selectedTab.id === 1;
      return true;
    },
    disabledKeyWords() {
      return this.isNew ? false : !this.dataSource.is_active;
    },
    formModel() {
      return models.cargoTypes.add;
    },
    isNew() {
      return !this.formData.uuid;
    }
  },
  data() {
    return {
      forwardingUnits: [],
      selectedTab: {
        title: 'Основная информация',
        id: 1
      },
      tabsItems: [
        {
          title: 'Основная информация',
          id: 1
        },
        {
          title: 'Ключевые слова',
          id: 2
        }
      ]
    };
  },
  methods: {
    onFocusOut(event, query) {
      if (query && query.length) {
        this.formData.key_words.push(query);
      }
    },
    onChangeTab(tab) {
      this.selectedTab = tab;
    },
    onSubmitHandler() {
      const data = cloneDeep(this.formData);
      this.$emit('submit', {
        formData: data,
        model: this.formModel
      });
    },
    async getTemperatureModeTypes() {
      try {
        const list = await api.temperature.getTemperatureModeTypes();
        list.unshift({
          uuid: 'null',
          title: 'Температурный режим не требуется'
        });

        return list.map(item => {
          return {
            ...item,
            icon:
              TEMPERATURE_MODE_ICONS_BY_NAME[item.title.toLowerCase()] || false
          };
        });
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки температурных режимов'
        });
        return [];
      }
    },
    async getForwardingUnits({ query, page, size }) {
      try {
        return await api.dictionaries.resources.getForwardingUnitList({ query, page, size })
      }
      catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        });
      }
    },
    deleteKeyWord(name) {
      const i = this.formData.key_words.indexOf(name);
      this.formData.key_words.splice(i, 1);
    }
  }
};
</script>

<style lang="scss" scoped>
.input-wrap {
  margin-bottom: 20px;
}
.input_container--inline {
  position: relative;
  display: flex;
  justify-content: space-between;

  .inline-block {
    display: inline-block;

    &:first-of-type {
      width: 85px;
    }

    &:last-of-type {
      width: 145px;
    }
  }
}
.custom-col {
  position: relative;
}
.custom-template {
  width: 100%;

  img {
    display: inline-block;
  }

  .custom-input {
    display: inline-block;
    width: calc(100% - 21px);
  }
}
.custom-row {
  margin-bottom: 20px;
}

.equal-char {
  position: absolute;
  top: 18px;
  right: -3px;
}
</style>
